/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2004, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
NetUsage ToolItem

*/


var nuc_contract_id = "@mozilla.org/netusagecom;1";
var nuc_cid = "{489e3485-7a4a-4438-9185-bf14c0c317ba}";


var nsNetUsageCom = {
	// nsINetUsageData
	get planname() { return this.usagedata.planname; },

	get usage() { return this.usagedata.usage; },
	get download() { return this.usagedata.download; },
	get upload() { return this.usagedata.upload; },
	get quota() { return this.usagedata.quota; },

	get usagepo() { return this.usagedata.usagepo; },
	get downloadpo() { return this.usagedata.downloadpo; },
	get uploadpo() { return this.usagedata.uploadpo; },
	get quotapo() { return this.usagedata.quotapo; },

	get startdate() { return this.usagedata.startdate.getTime(); },
	get enddate() { return this.usagedata.enddate.getTime(); },

	get lastfetched() { return this.fLastFetched; },

	get ispactive() { return (this.ISP != null); },
	get ispusagepageauth() { return this.ISP.usagePageAuth; },
	get ispusagepageauthrealm() { return this.ISP.usagePageAuthRealm; },
	get ispusagepageurl() { return this.ISP.usagePageUrl; },

	// nsNetUsageCom objects

	observe: function (subject, topic, data) {
		switch (topic) {
			case 'timer-callback':
			case 'netusage-update':
				// update usage
				if (data == 'actfirst') {
					if (this.firstTime) {
						this.firstTime = false;
						this.LoadPrefs();
						this.DoUpdateUsage();
					}
				} else {
					this.LoadPrefs();
					if (data != 'pref') this.DoUpdateUsage();
				}
				break;
			case 'xpcom-startup':
				this.Init();
				break;
		}
	},

	// initialize the object
	Init: function () {
		this.timer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
		this.xmlhttp = Components.classes['@mozilla.org/xmlextras/xmlhttprequest;1'].createInstance(Components.interfaces.nsIJSXMLHttpRequest).QueryInterface(Components.interfaces.nsIXMLHttpRequest);

		this.firstTime = true;
		this.fetching = false;
		this.secondtry = false;
		this.usagedata = null;
		this.fLastFetched = 0;

		this.ISP = null;
		this.checkInterval = 0;  // a weird (different) value to trigger the InitTimer

		var scriptinc = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService().QueryInterface(Components.interfaces.mozIJSSubScriptLoader);
		scriptinc.loadSubScript("chrome://netusagebtn/content/isps.js");
		scriptinc.loadSubScript("chrome://netusagebtn/content/usagelib.js");

		this.FillISPInterface = nuFillISPInterface;

		this.observerSvc = Components.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(Components.interfaces.nsIObserverService);
		this.observerSvc.addObserver(this, 'netusage-update', false);

		// doit !!!
		//this.observerSvc.notifyObservers(this, 'netusage-reload-prefs', null);
		//this.LoadPrefs();
                       //alert('hi');
		//if (this.ISP)
		//	observerSvc.notifyObservers(this, 'netusage-update-usage', null);

		// initial updatetimer
		//try {
		// make a delay'd reload preference, allow time for mozilla 1.4's internal pref's saving
		var prefrltimer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
		prefrltimer.init({ cmpn: Components,
			observe: function (subject, topic, data) {
				var observerSvc = this.cmpn.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(this.cmpn.interfaces.nsIObserverService);
				observerSvc.notifyObservers(null, 'netusage-update', 'usage');
			} }, 3000, prefrltimer.TYPE_ONE_SHOT);
		//} catch (e) { dump(e) };

	},

	// initialises timer
	InitTimer: function () {
		this.timer.cancel();
		if (this.ISP != null)
			this.timer.init(this, this.checkInterval, this.timer.TYPE_REPEATING_SLACK);
		else
			dump('disabled');
	},


	// this spawns a xmlhttp and updates usage
	DoUpdateUsage: function () {
		var ublogin;

		if (!this.ISP) return false;

		if (this.fetching) {
			// already trying to fetch, abort the fetch
			this.xmlhttp.abort();
			//for (z in this.xmlhttp) {
			//	this.observerSvc.notifyObservers(this, 'netusage-update-gui', z);
			//}

			// error
			this.observerSvc.notifyObservers(this, 'netusage-update-gui', 'error');

			this.fetching = false;
			this.secondtry = false;

			return false;
		} else {

			// start fetching
			if (!(ublogin = nuLoadPass('net:usage:bar')))
				return false;

			this.fetching = true;

			// url subing
			var url = this.ISP.url;
			url = url.replace(/{TIMESTAMP}/, Math.round((new Date()).getTime()/1000));
			url = url.replace(/{USERNAME}/, escape(ublogin[1]));
			url = url.replace(/{PASSWORD}/, escape(ublogin[2]));

			// GUI
			this.observerSvc.notifyObservers(this, 'netusage-update-gui', 'start');

			// fetch
			this.xmlhttp.onload = this.xmlhttpload;
			this.xmlhttp.onerror = this.xmlhttperror;

			try {
				this.xmlhttp.open('GET', url);
			} catch(e) { dump('caught open error:' + e); }

			if (this.ISP.urlAuth == nuISPAuthBasic)
				this.xmlhttp.setRequestHeader('Authorization', 'Basic ' + nuEncodeBase64(ublogin[1]+':'+ublogin[2]));

			this.xmlhttp.send(null);

		}
		return true;
	},


	// xmlhttp events
	xmlhttpload: function () {
		// this == xmlhttprequest

		if (!(nsNetUsageCom.usagedata = nsNetUsageCom.TranslateISP(this, nsNetUsageCom.ISP))) {
			nsNetUsageCom.xmlhttperror();
			return;
		}
		// GUI
		nsNetUsageCom.observerSvc.notifyObservers(this, 'netusage-update-gui', 'draw');

		// successfully fetched and parsed, THE END
		nsNetUsageCom.fetching = false;
		nsNetUsageCom.fLastFetched = nsNetUsageCom.usagedata.startdate.getTime();
	},
	xmlhttperror: function () {
		dump('LoadError');

		nsNetUsageCom.fetching = false;

		if (!nsNetUsageCom.secondtry) {
			// retry
			nsNetUsageCom.secondtry = true;

			// re-invoke metre
			//nsNetUsageCom.observerSvc.notifyObservers(this, 'netusage-update', 'usage');
			nsNetUsageCom.DoUpdateUsage();

		} else {
			// error
			this.observerSvc.notifyObservers(this, 'netusage-update-gui', 'error');
			nsNetUsageCom.fetching = false;
			nsNetUsageCom.secondtry = false;
		}
	},


	// transform ISP
	TranslateISP: function (httpobj, umISP) {

		if ('regexp1' in umISP) {
			var txtdoc = httpobj.responseText;
			if (!txtdoc) {
				dump('no txt doc');
				return false;
			}
			return nsNetUsageCom.TranslateISPRegExp(txtdoc, umISP);
		} else {
			var xmldoc = httpobj.responseXML;
			if (!xmldoc) {
				dump('no xml doc');
				return false;
			}
			return nsNetUsageCom.TranslateISPXML(xmldoc, umISP);
		}

	},
	TranslateISPXML: function (xmldoc, umISP) {
		var nodedl, nodeul, nodeqt, nodedlp, nodeulp, nodeqtp, nodedlpo, nodeulpo, nodeqtpo;

		if (!xmldoc.evaluate(umISP.xpVerify, xmldoc, null, 9, null).singleNodeValue) {
			dump('no xml node or Incorrect version');
			return null;
		}

		// all to do with dates
		// remember: illogical JS has 0 based months
		var daysInMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
		var astartdate, aenddate, xpdtar;
		var nowdate = new Date();
		var nowyear = nowdate.getFullYear();
		var nowmonth = nowdate.getMonth();
		// leap detection
		if (nowyear % 400 == 0 || (nowyear % 4 == 0 && nowyear % 100 != 0)) daysInMonth[1] = 29;


		var aplanname = ('xpPlanName' in umISP) ? xmldoc.evaluate(umISP.xpPlanName, xmldoc, null, 2, null).stringValue : '';


		if ('xpStartDate' in umISP) {
			// ISP has irregular billing cycles
			//var xpstartdate = '01-06-2003';
			//var xpenddate = '30-06-2003';
			var xpstartdate = xmldoc.evaluate(umISP.xpStartDate, xmldoc, null, 2, null).stringValue;
			var xpenddate = xmldoc.evaluate(umISP.xpEndDate, xmldoc, null, 2, null).stringValue;

			xpdtar = xpstartdate.split(/-/);
			astartdate = new Date(parseInt(xpdtar[2]), parseInt(xpdtar[1])-1, parseInt(xpdtar[0]), 0, 0, 0);
			xpdtar = xpenddate.split(/-/);
			aenddate = new Date(parseInt(xpdtar[2]), parseInt(xpdtar[1])-1, parseInt(xpdtar[0]), 23, 59, 59);

		} else {
			// ISP is day1 based
			astartdate = new Date(nowyear, nowmonth, 1, 0, 0, 0);
			aenddate = new Date(nowyear, nowmonth, daysInMonth[nowmonth], 23, 59, 59);
		}



		if (umISP.mode == nuISPNoUpOP && xmldoc.evaluate(umISP.xpDownloadPO, xmldoc, null, 9, null).singleNodeValue) {
			// on peak off peak mode
			var dl = parseInt(xmldoc.evaluate(umISP.xpDownloadP, xmldoc, null, 1, null).numberValue);
			var ul = parseInt(xmldoc.evaluate(umISP.xpUploadP, xmldoc, null, 1, null).numberValue);
			var qt = parseInt(xmldoc.evaluate(umISP.xpLimitP, xmldoc, null, 1, null).numberValue);
			var dlpo = parseInt(xmldoc.evaluate(umISP.xpDownloadPO, xmldoc, null, 1, null).numberValue);
			var ulpo = parseInt(xmldoc.evaluate(umISP.xpUploadPO, xmldoc, null, 1, null).numberValue);
			var qtpo = parseInt(xmldoc.evaluate(umISP.xpLimitPO, xmldoc, null, 1, null).numberValue);

			var used = dl;
			var usedpo = dlpo;
		} else {
			if (!xmldoc.evaluate(umISP.xpDownload, xmldoc, null, 9, null).singleNodeValue) {
				// assume no usage recorded
				var used = 0;
			} else {
				// no off peak on peak mode
				var dl = parseInt(xmldoc.evaluate(umISP.xpDownload, xmldoc, null, 1, null).numberValue);
				var ul = parseInt(xmldoc.evaluate(umISP.xpUpload, xmldoc, null, 1, null).numberValue);
				var qt = parseInt(xmldoc.evaluate(umISP.xpLimit, xmldoc, null, 1, null).numberValue);

				var dlpo = 0;
				var qtpo = 0;
				var ulpo = 0;
				var usedpo = 0;

				if (umISP.mode == nuISPRelax) {
					// relax and let us rip you off
					// bigpond 10GB "unlimited" plan is actually -1 MB ?!
					if (qt == -1) qt = 10000;
					var used = dl + ul;
				} else
					var used = dl;
			}
		}

		return {
			planname: aplanname,
			usage: used,
			usagepo: usedpo,
			download: dl,
			upload: ul,
			quota: qt,
			downloadpo: dlpo,
			uploadpo: ulpo,
			quotapo: qtpo,

			startdate: astartdate,
			enddate: aenddate
		}
	},
	TranslateISPRegExp: function (txtdoc, umISP) {
		var r = umISP.regexp1;
		var a;
		if (!(a = r.exec(txtdoc))) {
			dump('Incorrect html version - ISP changed their page layout');
			return null;
		}
		a[0] = '';

		// Currently only compatible with IINET
		aplanname = a[umISP.iPlanName];

			// DATES
			xpdtar = a[umISP.iStartDate].split(/-/);
			astartdate = new Date(parseInt(xpdtar[2]), parseInt(xpdtar[1])-1, parseInt(xpdtar[0]), 0, 0, 0);
			xpdtar = a[umISP.iEndDate].split(/-/);
			aenddate = new Date(parseInt(xpdtar[2]), parseInt(xpdtar[1])-1, parseInt(xpdtar[0]), 23, 59, 59);

			// ONPEAK/OFFPEAK usage
			var dl = parseInt(a[umISP.iDownloadP]);
			var ul = parseInt(a[umISP.iUploadP]);
			var qt = parseInt(a[umISP.iLimitP]);
			var dlpo = parseInt(a[umISP.iDownloadPO]);
			var ulpo = parseInt(a[umISP.iUploadPO]);
			var qtpo = parseInt(a[umISP.iLimitPO]);

			var used = dl;
			var usedpo = dlpo;

		return {
			planname: aplanname,
			usage: used,
			usagepo: usedpo,
			download: dl,
			upload: ul,
			quota: qt,
			downloadpo: dlpo,
			uploadpo: ulpo,
			quotapo: qtpo,

			startdate: astartdate,
			enddate: aenddate
		}
	},


	// load user preferences
	LoadPrefs: function () {
		var prefObj, pref, prefISP, prefCheckInterval;
		var doinittime = false;

		try {
			prefObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			pref = prefObj.getBranch("extensions.netusage.");
			prefISP = pref.getCharPref("userisp");
			if (prefISP && prefISP != '' && prefISP != 'na') {
				if (this.ISP == null || this.ISP.id != prefISP)
					this.ISP = this.FillISPInterface(prefISP);
			} else {
				if (this.ISP != null) {
					this.ISP = null;
					doinittime = true; // disable the timer
				}
			}
			prefCheckInterval = pref.getIntPref("checkinterval");
			// only change checkinterval if interval is greater than 10 mins (minimum req, so ISP servers aren't DOS'd)
			if (this.checkInterval != prefCheckInterval * 1000) {
				if (prefCheckInterval >= 600)
					this.checkInterval = prefCheckInterval * 1000;
				else
					this.checkInterval = 3600000;
				doinittime = true; // refresh timer interval
			}
			if (doinittime)
				this.InitTimer();
		} catch(e) { dump(e); }


	},


	QueryInterface: function (iid) {
		if (!iid.equals(Components.interfaces.nsINetUsageData) &&
			!iid.equals(Components.interfaces.nsISupports) &&
			!iid.equals(Components.interfaces.nsIObserver)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},

}




// This Component's module implementation.  All the code below is used to get this
// component registered and accessible via XPCOM.
var module = {
	firstTime: true,

	/* CID for this class */
	cid: Components.ID(nuc_cid),

	/* Contract ID for this class */
	contractId: nuc_contract_id,

	// registerSelf: Register this component.
	registerSelf: function (compMgr, fileSpec, location, type) {
		if (this.firstTime) {
			this.firstTime = false;
			throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
		}
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		//compMgr.registerComponentWithType( this.cid, "NetUsage Component", this.contractId, fileSpec, location, true, true, type);
		compMgr.registerFactoryLocation(this.cid, "NetUsage Component", this.contractId, fileSpec, location, type);

		var catman = Components.classes["@mozilla.org/categorymanager;1"].getService().QueryInterface(Components.interfaces.nsICategoryManager);
		catman.addCategoryEntry("xpcom-startup", "NetUsage", nuc_contract_id, true, true);
	},

	// getClassObject: Return this component's factory object.
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.cid)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}

		if (!iid.equals(Components.interfaces.nsIFactory)) {
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		}

		return this.factory;
	},

	/* factory object */
	factory: {
		createInstance: function (outer, iid) {
		if (outer != null)
			throw Components.results.NS_ERROR_NO_AGGREGATION;

			// a service
			return nsNetUsageCom.QueryInterface(iid);
		}
	},

	// canUnload: n/a (returns true)
	canUnload: function(compMgr) {
		return true;
	}
};

// NSGetModule: Return the nsIModule object.
function NSGetModule(compMgr, fileSpec) {
	return module;
}